// =============================================================================
//
// CBP_IProc_3.c
//
// CBP 28-12-20 Creation of 'L-Template' images for object recognition
//
// =============================================================================
#include <stdio.h>

#define NR_ROWS 7
#define NR_COLS 7


void convertArrayToImage( unsigned char inArray[][NR_COLS], unsigned char *image) {
	
  int row = 0;
  int col = 0;
  unsigned char arrayVal;

  for(row = 0; row < NR_ROWS; row++) {
    for(col = 0; col < NR_COLS; col++) {
	  arrayVal = inArray[row][col];
	  printf("arrayVal = %d\n",arrayVal);
	  *(image + col*4 + 1 + row*NR_COLS*4) = arrayVal;
	  *(image + col*4 + 2 + row*NR_COLS*4) = arrayVal;
	  *(image + col*4 + 3 + row*NR_COLS*4) = arrayVal;	  
	}
  }
	
}	

void dumpImage(unsigned char *image, int width, int height) {
	
  int row = 0;
  int col = 0;
  unsigned char pel;

  for(row = 0; row < height; row++) {
    for(col = 0; col < width; col++) {
	  pel = *(image + col*4 + 1 + row*width*4);
	  printf("%d ",pel);	  
	}
	printf("\n");
  }
  
}	

void dumpPattern(unsigned char inArray[][NR_COLS], int nrCols, int nrRows) {
	
  int row = 0;
  int col = 0;
  unsigned char val;

  for(row = 0; row < nrRows; row++) {
    for(col = 0; col < nrCols; col++) {
	  val = inArray[row][col];
	  printf("%d ",val);	  
	}
	printf("\n");
  }
  
} 

float imageImageOverlap(unsigned char *image1, unsigned char *image2, int width, int height) {
  int row = 0;
  int col = 0;
  unsigned char pel1, pel2;	
  float sum = 0;
	
  for(row = 0; row < height; row++) {
    for(col = 0; col < width; col++) {
	  pel1 = *(image1 + col*4 + 1 + row*width*4);
	  pel2 = *(image2 + col*4 + 1 + row*width*4);
	  sum += pel1*pel2;
	}
  }
  return sum;	
	
}	